﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage;
using Microsoft.EntityFrameworkCore.Storage.Internal;
using SEINN.Data.EntityFramework;
using System;

namespace SEINN.Data.EntityFramework.Migrations
{
    [DbContext(typeof(SEINNDbContext))]
    [Migration("20180305122208_InitMigration")]
    partial class InitMigration
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.0.1-rtm-125");

            modelBuilder.Entity("SIENN.Data.Model.Category", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Categories");
                });

            modelBuilder.Entity("SIENN.Data.Model.Product", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<DateTime>("DeliveryDate")
                        .HasColumnName("DeliveryDate")
                        .HasColumnType("date");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.Property<bool>("IsAvailabale")
                        .HasColumnName("IsAvailable")
                        .HasColumnType("Boolean");

                    b.Property<decimal>("Price")
                        .HasColumnType("decimal(7,2)");

                    b.HasKey("Code");

                    b.ToTable("Products");
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductCategory", b =>
                {
                    b.Property<string>("ProductCode");

                    b.Property<string>("CategoryCode");

                    b.Property<string>("CategoryId");

                    b.Property<string>("ProductId");

                    b.HasKey("ProductCode", "CategoryCode");

                    b.HasIndex("CategoryId");

                    b.HasIndex("ProductId");

                    b.ToTable("ProductsCategories");
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductType", b =>
                {
                    b.Property<string>("Code")
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Types");
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductUnit", b =>
                {
                    b.Property<string>("Code")
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Units");
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductCategory", b =>
                {
                    b.HasOne("SIENN.Data.Model.Category", "Category")
                        .WithMany("Products")
                        .HasForeignKey("CategoryId");

                    b.HasOne("SIENN.Data.Model.Product", "Product")
                        .WithMany("Categories")
                        .HasForeignKey("ProductId");
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductType", b =>
                {
                    b.HasOne("SIENN.Data.Model.Product")
                        .WithOne("Type")
                        .HasForeignKey("SIENN.Data.Model.ProductType", "Code")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("SIENN.Data.Model.ProductUnit", b =>
                {
                    b.HasOne("SIENN.Data.Model.Product")
                        .WithOne("Unit")
                        .HasForeignKey("SIENN.Data.Model.ProductUnit", "Code")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
